package com.arms.api.alm.issue.base.service.jiraissue_schedule.alm_entity_sync.req_issue;

import static org.junit.jupiter.api.Assertions.*;
import static org.mockito.BDDMockito.*;

import java.util.List;

import com.arms.api.issue.schedule.service.jiraissue_schedule.alm_entity_sync.req_issue.요구사항_이슈_수집;
import com.arms.api.project.dto.ProjectDTO;
import org.junit.jupiter.api.Test;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.boot.test.mock.mockito.MockBean;
import org.springframework.test.context.ActiveProfiles;

import com.arms.api.issue.almapi.model.vo.지라이슈_데이터;
import com.arms.api.issue.almapi.model.entity.AlmIssueEntity;
import com.arms.api.issue.almapi.model.dto.지라이슈필드_데이터;
import com.arms.api.issue.almapi.model.dto.요구사항_데이터;
import com.arms.api.issue.almapi.service.이슈전략_호출;

@SpringBootTest
@ActiveProfiles
class 요구사항이슈_처리Test {

	@MockBean
	private 이슈전략_호출 이슈전략_호출;

	@MockBean
	private com.arms.api.issue.schedule.service.jiraissue_schedule.alm_entity_sync.req_issue.요구사항_이슈_처리 요구사항_이슈_처리;

	@Test
	public void 요구사항_이동_테스트() throws Exception {

		요구사항_데이터 __요구사항_이슈데이터 = 요구사항_데이터.builder()
			.제품서비스_아이디(26L)
			.프로젝트키_또는_아이디("ATYHS")
			.cReqLink(32L)
			.이슈_키("ATYHS-40")
			.지라서버_아이디(7677459491337793718L)
			.제품서비스_버전들(List.of(82L,83L))
			.build();

		지라이슈_데이터 _지라이슈_데이터 = 지라이슈_데이터.builder()
			.key("YHS-40")
			.fields(지라이슈필드_데이터.builder().project(ProjectDTO.builder().id("ATYHS").build()).build())
			.build();
		when(이슈전략_호출.이슈_상세정보_가져오기(__요구사항_이슈데이터))
			.thenReturn(
				_지라이슈_데이터
			);

		요구사항_이슈_수집 요구사항_이슈_수집 = new 요구사항_이슈_수집(__요구사항_이슈데이터);
		List<AlmIssueEntity> 수집된_지라이슈_목록 = 요구사항_이슈_수집.수집된_지라이슈_목록_가져오기();

		assertTrue(__요구사항_이슈데이터.ALM_요구사항_존재_하면());

		assertEquals("YHS-40", __요구사항_이슈데이터.get이슈_키());

	}


}
