package com.arms.egovframework.javaservice.esframework.repository;

import java.util.List;

import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.data.elasticsearch.core.SearchHit;
import org.springframework.data.elasticsearch.core.query.NativeSearchQuery;
import org.springframework.test.context.ActiveProfiles;

import com.arms.api.issue.almapi.model.entity.AlmIssueEntity;
import com.arms.api.issue.almapi.repository.지라이슈_저장소;
import com.arms.egovframework.javaservice.esframework.esquery.EsQuery;
import com.arms.egovframework.javaservice.esframework.esquery.EsQueryBuilder;
import com.arms.egovframework.javaservice.esframework.factory.creator.기본_쿼리_생성기;
import com.arms.egovframework.javaservice.esframework.esquery.filter.TermsQueryFilter;
import com.arms.egovframework.javaservice.esframework.model.dto.기본_검색_요청;

@SpringBootTest
@ActiveProfiles("dev")
class 공통저장소_구현체Test {

    @Autowired
    private 지라이슈_저장소 지라이슈_저장소;

    @Test
    void findDocsByScrollApiTest(){


        EsQuery esQuery = new EsQueryBuilder()
            .bool(
                new TermsQueryFilter("key",295L)
            );


        NativeSearchQuery 생성 = 기본_쿼리_생성기.기본검색(esQuery).생성();

        List<SearchHit<AlmIssueEntity>> hitDocs = 지라이슈_저장소.findHitDocs(생성);
        System.out.println(hitDocs);

    }
}
